/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Myk Melez, myk@mozilla.org, original author
   - 
*/

// The local bugxula.rdf file containing user preferences, queries, 
// and Bugxula configuration.
var gUserDS = window.opener.gUserDS;
var gActiveSearch = window.opener.gActiveSearch;
var gInstallations = {};

function onLoad()
{
  // Populate the installations menu with the list of installations.
  var installations = document.getElementById('installations');
  installations.database.AddDataSource(gUserDS.ds);
  installations.builder.rebuild();
}

function onUnload()
{
  gUserDS.flush();
}

function toggleInstallation(control, event)
{
  var installationURI = control.id;
  
  if (control.getAttribute('checked'))
    gInstallations[installationURI] = true;
  else
    delete gInstallations[installationURI];
}

function runSearch()
{
  var installations = new Array();
  
  for (installation in gInstallations) 
    installations.push(installation);
  
  if (installations.length == 0)
  {
    alert("Please select some installations to search.");
    return;
  }
  
  var conditions = document.getElementById('conditions').value;
  
  // Extract conditions from URL if the user pasted in an entire URL.
  conditions = conditions.replace(/^(.*)\/buglist\.cgi\?(.*)$/, "$2");

  // Remove the "cmdtype" and "sort" parameters from the string.
  // These parameters don't mean anything for Bugxula, and Bugzilla
  // leaves them out of the URI for a search returning RDF results,
  // (this is probably a bug), so we have to trim them out in advance.
  conditions = conditions.replace(/cmdtype=[^\&]*\&?/, "");
  conditions = conditions.replace(/order=[^\&]*\&?/, "");
  
  // Make sure the conditions start with a preceding ampersand.
  if ( conditions.search(/^\&/) == -1 ) conditions = "&" + conditions;
  
  window.opener.deactivateSearch();
  window.opener.activateSearch(null, installations, conditions);
  window.close();
}

function cancelSearch()
{
  window.close();
}
